Contributing guidelines
=======================

We want to make contributing to this project as easy and transparent as
possible.

Our Development Process
-----------------------
Caterva2 development takes place around its Git repository hosted on GitHub:
<https://github.com/Blosc/Caterva2>.

New versions are being developed in the `main` branch,
or in their own feature branch.
When they are deemed ready for a release, they are merged back into `main`
again.

So all contributions must stage first through `main`
or their own feature branch.

Pull Requests
-------------
We actively welcome your pull requests.

1. Fork the repo and create your branch from `main`.
2. If you've added code that should be tested, add tests.
3. If you've changed APIs, update the documentation.
4. Ensure the test suite passes.
5. Make sure your code does not issue new compiler warnings.

Issues
------
We use GitHub issues to track public bugs. Please ensure your description is
clear and has sufficient instructions to be able to reproduce the issue.

License
-------
By contributing to Caterva2, you agree that your contributions will be licensed
under the [LICENSE](https://github.com/Blosc/Caterva2/blob/main/LICENSE.txt)
file of the project.
